package shub.dpm;

import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.pc.*;

public class listdata_subs_0 {


public static RemoteObject  _activity_create(RemoteObject _firsttime) throws Exception{
try {
		Debug.PushSubsStack("Activity_Create (listdata) ","listdata",10,listdata.mostCurrent.activityBA,listdata.mostCurrent,37);
if (RapidSub.canDelegate("activity_create")) { return shub.dpm.listdata.remoteMe.runUserSub(false, "listdata","activity_create", _firsttime);}
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 37;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(16);
 BA.debugLineNum = 38;BA.debugLine="init_view";
Debug.ShouldStop(32);
_init_view();
 BA.debugLineNum = 39;BA.debugLine="End Sub";
Debug.ShouldStop(64);
return RemoteObject.createImmutable("");
}
catch (Exception e) {
			throw Debug.ErrorCaught(e);
		} 
finally {
			Debug.PopSubsStack();
		}}
public static RemoteObject  _activity_pause(RemoteObject _userclosed) throws Exception{
try {
		Debug.PushSubsStack("Activity_Pause (listdata) ","listdata",10,listdata.mostCurrent.activityBA,listdata.mostCurrent,240);
if (RapidSub.canDelegate("activity_pause")) { return shub.dpm.listdata.remoteMe.runUserSub(false, "listdata","activity_pause", _userclosed);}
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 240;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(32768);
 BA.debugLineNum = 242;BA.debugLine="End Sub";
Debug.ShouldStop(131072);
return RemoteObject.createImmutable("");
}
catch (Exception e) {
			throw Debug.ErrorCaught(e);
		} 
finally {
			Debug.PopSubsStack();
		}}
public static RemoteObject  _activity_resume() throws Exception{
try {
		Debug.PushSubsStack("Activity_Resume (listdata) ","listdata",10,listdata.mostCurrent.activityBA,listdata.mostCurrent,236);
if (RapidSub.canDelegate("activity_resume")) { return shub.dpm.listdata.remoteMe.runUserSub(false, "listdata","activity_resume");}
 BA.debugLineNum = 236;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(2048);
 BA.debugLineNum = 238;BA.debugLine="End Sub";
Debug.ShouldStop(8192);
return RemoteObject.createImmutable("");
}
catch (Exception e) {
			throw Debug.ErrorCaught(e);
		} 
finally {
			Debug.PopSubsStack();
		}}
public static RemoteObject  _addrow(RemoteObject _values) throws Exception{
try {
		Debug.PushSubsStack("AddRow (listdata) ","listdata",10,listdata.mostCurrent.activityBA,listdata.mostCurrent,178);
if (RapidSub.canDelegate("addrow")) { return shub.dpm.listdata.remoteMe.runUserSub(false, "listdata","addrow", _values);}
RemoteObject _lastrow = RemoteObject.createImmutable(0);
int _i = 0;
RemoteObject _l = RemoteObject.declareNull("anywheresoftware.b4a.objects.LabelWrapper");
RemoteObject _rc = RemoteObject.declareNull("shub.dpm.listdata._rowcol");
Debug.locals.put("Values", _values);
 BA.debugLineNum = 178;BA.debugLine="Sub AddRow(Values() As String)";
Debug.ShouldStop(131072);
 BA.debugLineNum = 179;BA.debugLine="If Values.Length <> NumberOfColumns Then";
Debug.ShouldStop(262144);
if (RemoteObject.solveBoolean("!",_values.getField(true,"length"),BA.numberCast(double.class, listdata._numberofcolumns))) { 
 BA.debugLineNum = 180;BA.debugLine="Log(\"Wrong number of values.\")";
Debug.ShouldStop(524288);
listdata.mostCurrent.__c.runVoidMethod ("LogImpl","16356994",RemoteObject.createImmutable("Wrong number of values."),0);
 BA.debugLineNum = 181;BA.debugLine="Return";
Debug.ShouldStop(1048576);
if (true) return RemoteObject.createImmutable("");
 };
 BA.debugLineNum = 183;BA.debugLine="Dim lastRow As Int";
Debug.ShouldStop(4194304);
_lastrow = RemoteObject.createImmutable(0);Debug.locals.put("lastRow", _lastrow);
 BA.debugLineNum = 184;BA.debugLine="lastRow = NumberOfRows";
Debug.ShouldStop(8388608);
_lastrow = _numberofrows();Debug.locals.put("lastRow", _lastrow);
 BA.debugLineNum = 185;BA.debugLine="For i = 0 To NumberOfColumns - 1";
Debug.ShouldStop(16777216);
{
final int step7 = 1;
final int limit7 = RemoteObject.solve(new RemoteObject[] {listdata._numberofcolumns,RemoteObject.createImmutable(1)}, "-",1, 1).<Integer>get().intValue();
_i = 0 ;
for (;(step7 > 0 && _i <= limit7) || (step7 < 0 && _i >= limit7) ;_i = ((int)(0 + _i + step7))  ) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 186;BA.debugLine="Dim l As Label";
Debug.ShouldStop(33554432);
_l = RemoteObject.createNew ("anywheresoftware.b4a.objects.LabelWrapper");Debug.locals.put("l", _l);
 BA.debugLineNum = 187;BA.debugLine="l.Initialize(\"cell\")";
Debug.ShouldStop(67108864);
_l.runVoidMethod ("Initialize",listdata.mostCurrent.activityBA,(Object)(RemoteObject.createImmutable("cell")));
 BA.debugLineNum = 188;BA.debugLine="l.Text = Values(i)";
Debug.ShouldStop(134217728);
_l.runMethod(true,"setText",BA.ObjectToCharSequence(_values.getArrayElement(true,BA.numberCast(int.class, _i))));
 BA.debugLineNum = 189;BA.debugLine="l.Gravity = Alignment";
Debug.ShouldStop(268435456);
_l.runMethod(true,"setGravity",listdata._alignment);
 BA.debugLineNum = 190;BA.debugLine="l.TextSize = FontSize";
Debug.ShouldStop(536870912);
_l.runMethod(true,"setTextSize",listdata._fontsize);
 BA.debugLineNum = 191;BA.debugLine="l.TextColor = FontColor";
Debug.ShouldStop(1073741824);
_l.runMethod(true,"setTextColor",listdata._fontcolor);
 BA.debugLineNum = 192;BA.debugLine="Dim rc As RowCol";
Debug.ShouldStop(-2147483648);
_rc = RemoteObject.createNew ("shub.dpm.listdata._rowcol");Debug.locals.put("rc", _rc);
 BA.debugLineNum = 193;BA.debugLine="rc.Initialize";
Debug.ShouldStop(1);
_rc.runVoidMethod ("Initialize");
 BA.debugLineNum = 194;BA.debugLine="rc.Col = i";
Debug.ShouldStop(2);
_rc.setField ("Col" /*RemoteObject*/ ,BA.numberCast(int.class, _i));
 BA.debugLineNum = 195;BA.debugLine="rc.Row = lastRow";
Debug.ShouldStop(4);
_rc.setField ("Row" /*RemoteObject*/ ,_lastrow);
 BA.debugLineNum = 196;BA.debugLine="l.Tag = rc";
Debug.ShouldStop(8);
_l.runMethod(false,"setTag",(_rc));
 BA.debugLineNum = 197;BA.debugLine="Table.AddView(l, ColumnWidth * i, RowHeight * la";
Debug.ShouldStop(16);
listdata.mostCurrent._table.runVoidMethod ("AddView",(Object)((_l.getObject())),(Object)(RemoteObject.solve(new RemoteObject[] {listdata._columnwidth,RemoteObject.createImmutable(_i)}, "*",0, 1)),(Object)(RemoteObject.solve(new RemoteObject[] {listdata._rowheight,_lastrow}, "*",0, 1)),(Object)(listdata._columnwidth),(Object)(listdata._rowheight));
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 199;BA.debugLine="Table.Height = NumberOfRows * RowHeight";
Debug.ShouldStop(64);
listdata.mostCurrent._table.runMethod(true,"setHeight",RemoteObject.solve(new RemoteObject[] {_numberofrows(),listdata._rowheight}, "*",0, 1));
 BA.debugLineNum = 200;BA.debugLine="End Sub";
Debug.ShouldStop(128);
return RemoteObject.createImmutable("");
}
catch (Exception e) {
			throw Debug.ErrorCaught(e);
		} 
finally {
			Debug.PopSubsStack();
		}}
public static RemoteObject  _bclose_click() throws Exception{
try {
		Debug.PushSubsStack("bClose_Click (listdata) ","listdata",10,listdata.mostCurrent.activityBA,listdata.mostCurrent,245);
if (RapidSub.canDelegate("bclose_click")) { return shub.dpm.listdata.remoteMe.runUserSub(false, "listdata","bclose_click");}
 BA.debugLineNum = 245;BA.debugLine="Private Sub bClose_Click";
Debug.ShouldStop(1048576);
 BA.debugLineNum = 246;BA.debugLine="Activity.Finish";
Debug.ShouldStop(2097152);
listdata.mostCurrent._activity.runVoidMethod ("Finish");
 BA.debugLineNum = 248;BA.debugLine="End Sub";
Debug.ShouldStop(8388608);
return RemoteObject.createImmutable("");
}
catch (Exception e) {
			throw Debug.ErrorCaught(e);
		} 
finally {
			Debug.PopSubsStack();
		}}
public static RemoteObject  _cell_click() throws Exception{
try {
		Debug.PushSubsStack("Cell_Click (listdata) ","listdata",10,listdata.mostCurrent.activityBA,listdata.mostCurrent,139);
if (RapidSub.canDelegate("cell_click")) { return shub.dpm.listdata.remoteMe.runUserSub(false, "listdata","cell_click");}
RemoteObject _rc = RemoteObject.declareNull("shub.dpm.listdata._rowcol");
RemoteObject _l = RemoteObject.declareNull("anywheresoftware.b4a.objects.LabelWrapper");
int _i = 0;
RemoteObject _map1 = RemoteObject.declareNull("anywheresoftware.b4a.objects.collections.Map");
 BA.debugLineNum = 139;BA.debugLine="Sub Cell_Click";
Debug.ShouldStop(1024);
 BA.debugLineNum = 140;BA.debugLine="Dim rc As RowCol";
Debug.ShouldStop(2048);
_rc = RemoteObject.createNew ("shub.dpm.listdata._rowcol");Debug.locals.put("rc", _rc);
 BA.debugLineNum = 141;BA.debugLine="Dim l As Label";
Debug.ShouldStop(4096);
_l = RemoteObject.createNew ("anywheresoftware.b4a.objects.LabelWrapper");Debug.locals.put("l", _l);
 BA.debugLineNum = 142;BA.debugLine="l = Sender";
Debug.ShouldStop(8192);
_l = RemoteObject.declareNull("anywheresoftware.b4a.AbsObjectWrapper").runMethod(false, "ConvertToWrapper", RemoteObject.createNew("anywheresoftware.b4a.objects.LabelWrapper"), listdata.mostCurrent.__c.runMethod(false,"Sender",listdata.mostCurrent.activityBA));
 BA.debugLineNum = 143;BA.debugLine="rc = l.Tag";
Debug.ShouldStop(16384);
_rc = (_l.runMethod(false,"getTag"));Debug.locals.put("rc", _rc);
 BA.debugLineNum = 144;BA.debugLine="SelectRow(rc.Row)";
Debug.ShouldStop(32768);
_selectrow(_rc.getField(true,"Row" /*RemoteObject*/ ));
 BA.debugLineNum = 146;BA.debugLine="For i=0 To list1.Size-1";
Debug.ShouldStop(131072);
{
final int step6 = 1;
final int limit6 = RemoteObject.solve(new RemoteObject[] {listdata.mostCurrent._list1.runMethod(true,"getSize"),RemoteObject.createImmutable(1)}, "-",1, 1).<Integer>get().intValue();
_i = 0 ;
for (;(step6 > 0 && _i <= limit6) || (step6 < 0 && _i >= limit6) ;_i = ((int)(0 + _i + step6))  ) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 147;BA.debugLine="If i=rc.Row Then";
Debug.ShouldStop(262144);
if (RemoteObject.solveBoolean("=",RemoteObject.createImmutable(_i),BA.numberCast(double.class, _rc.getField(true,"Row" /*RemoteObject*/ )))) { 
 BA.debugLineNum = 148;BA.debugLine="Dim map1 As Map";
Debug.ShouldStop(524288);
_map1 = RemoteObject.createNew ("anywheresoftware.b4a.objects.collections.Map");Debug.locals.put("map1", _map1);
 BA.debugLineNum = 149;BA.debugLine="map1=list1.Get(i)";
Debug.ShouldStop(1048576);
_map1 = RemoteObject.declareNull("anywheresoftware.b4a.AbsObjectWrapper").runMethod(false, "ConvertToWrapper", RemoteObject.createNew("anywheresoftware.b4a.objects.collections.Map"), listdata.mostCurrent._list1.runMethod(false,"Get",(Object)(BA.numberCast(int.class, _i))));
 };
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 153;BA.debugLine="End Sub";
Debug.ShouldStop(16777216);
return RemoteObject.createImmutable("");
}
catch (Exception e) {
			throw Debug.ErrorCaught(e);
		} 
finally {
			Debug.PopSubsStack();
		}}
public static void  _cell_longclick() throws Exception{
try {
		Debug.PushSubsStack("Cell_LongClick (listdata) ","listdata",10,listdata.mostCurrent.activityBA,listdata.mostCurrent,109);
if (RapidSub.canDelegate("cell_longclick")) { shub.dpm.listdata.remoteMe.runUserSub(false, "listdata","cell_longclick"); return;}
ResumableSub_Cell_LongClick rsub = new ResumableSub_Cell_LongClick(null);
rsub.resume(null, null);
}
catch (Exception e) {
			throw Debug.ErrorCaught(e);
		} 
finally {
			Debug.PopSubsStack();
		}}
public static class ResumableSub_Cell_LongClick extends BA.ResumableSub {
public ResumableSub_Cell_LongClick(shub.dpm.listdata parent) {
this.parent = parent;
}
java.util.LinkedHashMap<String, Object> rsLocals = new java.util.LinkedHashMap<String, Object>();
shub.dpm.listdata parent;
RemoteObject _rc = RemoteObject.declareNull("shub.dpm.listdata._rowcol");
RemoteObject _l = RemoteObject.declareNull("anywheresoftware.b4a.objects.LabelWrapper");
RemoteObject _x = RemoteObject.createImmutable("");
int _i = 0;
RemoteObject _map1 = RemoteObject.declareNull("anywheresoftware.b4a.objects.collections.Map");
RemoteObject _result = RemoteObject.createImmutable(0);
RemoteObject _job = RemoteObject.declareNull("shub.dpm.httpjob");
int step8;
int limit8;

@Override
public void resume(BA ba, RemoteObject result) throws Exception{
try {
		Debug.PushSubsStack("Cell_LongClick (listdata) ","listdata",10,listdata.mostCurrent.activityBA,listdata.mostCurrent,109);
Debug.locals = rsLocals;Debug.currentSubFrame.locals = rsLocals;

    while (true) {
        switch (state) {
            case -1:
return;

case 0:
//C
this.state = 1;
 BA.debugLineNum = 110;BA.debugLine="Dim rc As RowCol";
Debug.ShouldStop(8192);
_rc = RemoteObject.createNew ("shub.dpm.listdata._rowcol");Debug.locals.put("rc", _rc);
 BA.debugLineNum = 111;BA.debugLine="Dim l As Label";
Debug.ShouldStop(16384);
_l = RemoteObject.createNew ("anywheresoftware.b4a.objects.LabelWrapper");Debug.locals.put("l", _l);
 BA.debugLineNum = 112;BA.debugLine="Dim x As String";
Debug.ShouldStop(32768);
_x = RemoteObject.createImmutable("");Debug.locals.put("x", _x);
 BA.debugLineNum = 113;BA.debugLine="x=\"\"";
Debug.ShouldStop(65536);
_x = BA.ObjectToString("");Debug.locals.put("x", _x);
 BA.debugLineNum = 114;BA.debugLine="l = Sender";
Debug.ShouldStop(131072);
_l = RemoteObject.declareNull("anywheresoftware.b4a.AbsObjectWrapper").runMethod(false, "ConvertToWrapper", RemoteObject.createNew("anywheresoftware.b4a.objects.LabelWrapper"), parent.mostCurrent.__c.runMethod(false,"Sender",listdata.mostCurrent.activityBA));
 BA.debugLineNum = 115;BA.debugLine="rc = l.Tag";
Debug.ShouldStop(262144);
_rc = (_l.runMethod(false,"getTag"));Debug.locals.put("rc", _rc);
 BA.debugLineNum = 116;BA.debugLine="SelectRow(rc.Row)";
Debug.ShouldStop(524288);
_selectrow(_rc.getField(true,"Row" /*RemoteObject*/ ));
 BA.debugLineNum = 118;BA.debugLine="For i=0 To list1.Size-1";
Debug.ShouldStop(2097152);
if (true) break;

case 1:
//for
this.state = 8;
step8 = 1;
limit8 = RemoteObject.solve(new RemoteObject[] {parent.mostCurrent._list1.runMethod(true,"getSize"),RemoteObject.createImmutable(1)}, "-",1, 1).<Integer>get().intValue();
_i = 0 ;
Debug.locals.put("i", _i);
this.state = 16;
if (true) break;

case 16:
//C
this.state = 8;
if ((step8 > 0 && _i <= limit8) || (step8 < 0 && _i >= limit8)) this.state = 3;
if (true) break;

case 17:
//C
this.state = 16;
_i = ((int)(0 + _i + step8)) ;
Debug.locals.put("i", _i);
if (true) break;

case 3:
//C
this.state = 4;
 BA.debugLineNum = 119;BA.debugLine="If i=rc.Row Then";
Debug.ShouldStop(4194304);
if (true) break;

case 4:
//if
this.state = 7;
if (RemoteObject.solveBoolean("=",RemoteObject.createImmutable(_i),BA.numberCast(double.class, _rc.getField(true,"Row" /*RemoteObject*/ )))) { 
this.state = 6;
}if (true) break;

case 6:
//C
this.state = 7;
 BA.debugLineNum = 120;BA.debugLine="Dim map1 As Map";
Debug.ShouldStop(8388608);
_map1 = RemoteObject.createNew ("anywheresoftware.b4a.objects.collections.Map");Debug.locals.put("map1", _map1);
 BA.debugLineNum = 121;BA.debugLine="map1=list1.Get(i)";
Debug.ShouldStop(16777216);
_map1 = RemoteObject.declareNull("anywheresoftware.b4a.AbsObjectWrapper").runMethod(false, "ConvertToWrapper", RemoteObject.createNew("anywheresoftware.b4a.objects.collections.Map"), parent.mostCurrent._list1.runMethod(false,"Get",(Object)(BA.numberCast(int.class, _i))));
 BA.debugLineNum = 122;BA.debugLine="x=map1.Get(\"id\")";
Debug.ShouldStop(33554432);
_x = BA.ObjectToString(_map1.runMethod(false,"Get",(Object)((RemoteObject.createImmutable("id")))));Debug.locals.put("x", _x);
 if (true) break;

case 7:
//C
this.state = 17;
;
 if (true) break;
if (true) break;
Debug.locals.put("i", _i);
;
 BA.debugLineNum = 127;BA.debugLine="If x<>\"\" Then";
Debug.ShouldStop(1073741824);

case 8:
//if
this.state = 15;
if (RemoteObject.solveBoolean("!",_x,BA.ObjectToString(""))) { 
this.state = 10;
}if (true) break;

case 10:
//C
this.state = 11;
 BA.debugLineNum = 128;BA.debugLine="Msgbox2Async(\"Eintrag Nr. \"&x&\" wirkllich lösche";
Debug.ShouldStop(-2147483648);
parent.mostCurrent.__c.runVoidMethod ("Msgbox2Async",(Object)(BA.ObjectToCharSequence(RemoteObject.concat(RemoteObject.createImmutable("Eintrag Nr. "),_x,RemoteObject.createImmutable(" wirkllich löschen?")))),(Object)(BA.ObjectToCharSequence("Charge-Eintrag löschen")),(Object)(BA.ObjectToString("Ja")),(Object)(BA.ObjectToString("Nein")),(Object)(BA.ObjectToString("")),RemoteObject.declareNull("anywheresoftware.b4a.AbsObjectWrapper").runMethod(false, "ConvertToWrapper", RemoteObject.createNew("anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper"), parent.mostCurrent.__c.getField(false,"Null")),listdata.processBA,(Object)(parent.mostCurrent.__c.getField(true,"False")));
 BA.debugLineNum = 129;BA.debugLine="Wait For MsgBox_Result (Result As Int)";
Debug.ShouldStop(1);
parent.mostCurrent.__c.runVoidMethod ("WaitFor","msgbox_result", listdata.processBA, anywheresoftware.b4a.pc.PCResumableSub.createDebugResumeSub(this, "listdata", "cell_longclick"), null);
this.state = 18;
return;
case 18:
//C
this.state = 11;
_result = (RemoteObject) result.getArrayElement(true,RemoteObject.createImmutable(0));Debug.locals.put("Result", _result);
;
 BA.debugLineNum = 130;BA.debugLine="If Result = DialogResponse.POSITIVE Then";
Debug.ShouldStop(2);
if (true) break;

case 11:
//if
this.state = 14;
if (RemoteObject.solveBoolean("=",_result,BA.numberCast(double.class, parent.mostCurrent.__c.getField(false,"DialogResponse").getField(true,"POSITIVE")))) { 
this.state = 13;
}if (true) break;

case 13:
//C
this.state = 14;
 BA.debugLineNum = 131;BA.debugLine="Dim job As HttpJob";
Debug.ShouldStop(4);
_job = RemoteObject.createNew ("shub.dpm.httpjob");Debug.locals.put("job", _job);
 BA.debugLineNum = 132;BA.debugLine="jobname=\"DelData\"";
Debug.ShouldStop(8);
parent.mostCurrent._jobname = BA.ObjectToString("DelData");
 BA.debugLineNum = 133;BA.debugLine="job.Initialize(jobname, Me)";
Debug.ShouldStop(16);
_job.runClassMethod (shub.dpm.httpjob.class, "_initialize" /*RemoteObject*/ ,listdata.processBA,(Object)(parent.mostCurrent._jobname),(Object)(listdata.getObject()));
 BA.debugLineNum = 134;BA.debugLine="job.Delete(AllgFnkt.sURL&\"/DPMService/api/PatCh";
Debug.ShouldStop(32);
_job.runClassMethod (shub.dpm.httpjob.class, "_delete" /*RemoteObject*/ ,(Object)(RemoteObject.concat(parent.mostCurrent._allgfnkt._surl /*RemoteObject*/ ,RemoteObject.createImmutable("/DPMService/api/PatCharge/"),_x)));
 if (true) break;

case 14:
//C
this.state = 15;
;
 if (true) break;

case 15:
//C
this.state = -1;
;
 BA.debugLineNum = 137;BA.debugLine="End Sub";
Debug.ShouldStop(256);
if (true) break;

            }
        }
    }
catch (Exception e) {
			throw Debug.ErrorCaught(e);
		} 
finally {
			Debug.PopSubsStack();
		}}
}
public static void  _msgbox_result(RemoteObject _result) throws Exception{
}
public static RemoteObject  _clearall() throws Exception{
try {
		Debug.PushSubsStack("ClearAll (listdata) ","listdata",10,listdata.mostCurrent.activityBA,listdata.mostCurrent,229);
if (RapidSub.canDelegate("clearall")) { return shub.dpm.listdata.remoteMe.runUserSub(false, "listdata","clearall");}
int _i = 0;
 BA.debugLineNum = 229;BA.debugLine="Sub ClearAll";
Debug.ShouldStop(16);
 BA.debugLineNum = 230;BA.debugLine="For i = Table.NumberOfViews -1 To 0 Step -1";
Debug.ShouldStop(32);
{
final int step1 = -1;
final int limit1 = 0;
_i = RemoteObject.solve(new RemoteObject[] {listdata.mostCurrent._table.runMethod(true,"getNumberOfViews"),RemoteObject.createImmutable(1)}, "-",1, 1).<Integer>get().intValue() ;
for (;(step1 > 0 && _i <= limit1) || (step1 < 0 && _i >= limit1) ;_i = ((int)(0 + _i + step1))  ) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 231;BA.debugLine="Table.RemoveViewAt(i)";
Debug.ShouldStop(64);
listdata.mostCurrent._table.runVoidMethod ("RemoveViewAt",(Object)(BA.numberCast(int.class, _i)));
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 233;BA.debugLine="Table.Height = 0";
Debug.ShouldStop(256);
listdata.mostCurrent._table.runMethod(true,"setHeight",BA.numberCast(int.class, 0));
 BA.debugLineNum = 234;BA.debugLine="SelectedRow = -1";
Debug.ShouldStop(512);
listdata._selectedrow = BA.numberCast(int.class, -(double) (0 + 1));
 BA.debugLineNum = 235;BA.debugLine="End Sub";
Debug.ShouldStop(1024);
return RemoteObject.createImmutable("");
}
catch (Exception e) {
			throw Debug.ErrorCaught(e);
		} 
finally {
			Debug.PopSubsStack();
		}}
public static RemoteObject  _get_data() throws Exception{
try {
		Debug.PushSubsStack("Get_Data (listdata) ","listdata",10,listdata.mostCurrent.activityBA,listdata.mostCurrent,59);
if (RapidSub.canDelegate("get_data")) { return shub.dpm.listdata.remoteMe.runUserSub(false, "listdata","get_data");}
RemoteObject _job = RemoteObject.declareNull("shub.dpm.httpjob");
 BA.debugLineNum = 59;BA.debugLine="Sub Get_Data";
Debug.ShouldStop(67108864);
 BA.debugLineNum = 60;BA.debugLine="Dim job As HttpJob";
Debug.ShouldStop(134217728);
_job = RemoteObject.createNew ("shub.dpm.httpjob");Debug.locals.put("job", _job);
 BA.debugLineNum = 61;BA.debugLine="jobname=\"GetData\"";
Debug.ShouldStop(268435456);
listdata.mostCurrent._jobname = BA.ObjectToString("GetData");
 BA.debugLineNum = 62;BA.debugLine="job.Initialize(jobname, Me)";
Debug.ShouldStop(536870912);
_job.runClassMethod (shub.dpm.httpjob.class, "_initialize" /*RemoteObject*/ ,listdata.processBA,(Object)(listdata.mostCurrent._jobname),(Object)(listdata.getObject()));
 BA.debugLineNum = 64;BA.debugLine="job.Download(AllgFnkt.sURL&\"/DPMService/api/PatCh";
Debug.ShouldStop(-2147483648);
_job.runClassMethod (shub.dpm.httpjob.class, "_download" /*RemoteObject*/ ,(Object)(RemoteObject.concat(listdata.mostCurrent._allgfnkt._surl /*RemoteObject*/ ,RemoteObject.createImmutable("/DPMService/api/PatCharge/"),listdata.mostCurrent._allgfnkt._patid /*RemoteObject*/ )));
 BA.debugLineNum = 65;BA.debugLine="End Sub";
Debug.ShouldStop(1);
return RemoteObject.createImmutable("");
}
catch (Exception e) {
			throw Debug.ErrorCaught(e);
		} 
finally {
			Debug.PopSubsStack();
		}}
public static RemoteObject  _getcell(RemoteObject _row,RemoteObject _col) throws Exception{
try {
		Debug.PushSubsStack("GetCell (listdata) ","listdata",10,listdata.mostCurrent.activityBA,listdata.mostCurrent,226);
if (RapidSub.canDelegate("getcell")) { return shub.dpm.listdata.remoteMe.runUserSub(false, "listdata","getcell", _row, _col);}
Debug.locals.put("Row", _row);
Debug.locals.put("Col", _col);
 BA.debugLineNum = 226;BA.debugLine="Sub GetCell(Row As Int, Col As Int) As String";
Debug.ShouldStop(2);
 BA.debugLineNum = 227;BA.debugLine="Return GetView(Row, Col).Text";
Debug.ShouldStop(4);
if (true) return _getview(_row,_col).runMethod(true,"getText");
 BA.debugLineNum = 228;BA.debugLine="End Sub";
Debug.ShouldStop(8);
return RemoteObject.createImmutable("");
}
catch (Exception e) {
			throw Debug.ErrorCaught(e);
		} 
finally {
			Debug.PopSubsStack();
		}}
public static RemoteObject  _getview(RemoteObject _row,RemoteObject _col) throws Exception{
try {
		Debug.PushSubsStack("GetView (listdata) ","listdata",10,listdata.mostCurrent.activityBA,listdata.mostCurrent,173);
if (RapidSub.canDelegate("getview")) { return shub.dpm.listdata.remoteMe.runUserSub(false, "listdata","getview", _row, _col);}
RemoteObject _l = RemoteObject.declareNull("anywheresoftware.b4a.objects.LabelWrapper");
Debug.locals.put("Row", _row);
Debug.locals.put("Col", _col);
 BA.debugLineNum = 173;BA.debugLine="Sub GetView(Row As Int, Col As Int) As Label";
Debug.ShouldStop(4096);
 BA.debugLineNum = 174;BA.debugLine="Dim l As Label";
Debug.ShouldStop(8192);
_l = RemoteObject.createNew ("anywheresoftware.b4a.objects.LabelWrapper");Debug.locals.put("l", _l);
 BA.debugLineNum = 175;BA.debugLine="l = Table.GetView(Row * NumberOfColumns + Col)";
Debug.ShouldStop(16384);
_l = RemoteObject.declareNull("anywheresoftware.b4a.AbsObjectWrapper").runMethod(false, "ConvertToWrapper", RemoteObject.createNew("anywheresoftware.b4a.objects.LabelWrapper"), listdata.mostCurrent._table.runMethod(false,"GetView",(Object)(RemoteObject.solve(new RemoteObject[] {_row,listdata._numberofcolumns,_col}, "*+",1, 1))).getObject());
 BA.debugLineNum = 176;BA.debugLine="Return l";
Debug.ShouldStop(32768);
if (true) return _l;
 BA.debugLineNum = 177;BA.debugLine="End Sub";
Debug.ShouldStop(65536);
return RemoteObject.createImmutable(null);
}
catch (Exception e) {
			throw Debug.ErrorCaught(e);
		} 
finally {
			Debug.PopSubsStack();
		}}
public static RemoteObject  _globals() throws Exception{
 //BA.debugLineNum = 10;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 11;BA.debugLine="Dim jobname As String";
listdata.mostCurrent._jobname = RemoteObject.createImmutable("");
 //BA.debugLineNum = 12;BA.debugLine="Dim SV As ScrollView";
listdata.mostCurrent._sv = RemoteObject.createNew ("anywheresoftware.b4a.objects.ScrollViewWrapper");
 //BA.debugLineNum = 13;BA.debugLine="Dim BtnClose As Button";
listdata.mostCurrent._btnclose = RemoteObject.createNew ("anywheresoftware.b4a.objects.ButtonWrapper");
 //BA.debugLineNum = 14;BA.debugLine="Dim Header As Panel";
listdata.mostCurrent._header = RemoteObject.createNew ("anywheresoftware.b4a.objects.PanelWrapper");
 //BA.debugLineNum = 15;BA.debugLine="Dim Table As Panel";
listdata.mostCurrent._table = RemoteObject.createNew ("anywheresoftware.b4a.objects.PanelWrapper");
 //BA.debugLineNum = 16;BA.debugLine="Dim NumberOfColumns, RowHeight, ColumnWidth As In";
listdata._numberofcolumns = RemoteObject.createImmutable(0);
listdata._rowheight = RemoteObject.createImmutable(0);
listdata._columnwidth = RemoteObject.createImmutable(0);
 //BA.debugLineNum = 17;BA.debugLine="Dim HeaderColor, TableColor, FontColor, HeaderFon";
listdata._headercolor = RemoteObject.createImmutable(0);
listdata._tablecolor = RemoteObject.createImmutable(0);
listdata._fontcolor = RemoteObject.createImmutable(0);
listdata._headerfontcolor = RemoteObject.createImmutable(0);
 //BA.debugLineNum = 18;BA.debugLine="Dim FontSize As Float";
listdata._fontsize = RemoteObject.createImmutable(0f);
 //BA.debugLineNum = 19;BA.debugLine="Type RowCol (Row As Int, Col As Int)";
;
 //BA.debugLineNum = 20;BA.debugLine="Dim Alignment As Int";
listdata._alignment = RemoteObject.createImmutable(0);
 //BA.debugLineNum = 21;BA.debugLine="Dim SelectedRow As Int";
listdata._selectedrow = RemoteObject.createImmutable(0);
 //BA.debugLineNum = 22;BA.debugLine="Dim SelectedRowColor As Int";
listdata._selectedrowcolor = RemoteObject.createImmutable(0);
 //BA.debugLineNum = 25;BA.debugLine="HeaderColor = Colors.Gray";
listdata._headercolor = listdata.mostCurrent.__c.getField(false,"Colors").getField(true,"Gray");
 //BA.debugLineNum = 26;BA.debugLine="NumberOfColumns = 3";
listdata._numberofcolumns = BA.numberCast(int.class, 3);
 //BA.debugLineNum = 27;BA.debugLine="RowHeight = 30dip";
listdata._rowheight = listdata.mostCurrent.__c.runMethod(true,"DipToCurrent",(Object)(BA.numberCast(int.class, 30)));
 //BA.debugLineNum = 28;BA.debugLine="TableColor = Colors.White";
listdata._tablecolor = listdata.mostCurrent.__c.getField(false,"Colors").getField(true,"White");
 //BA.debugLineNum = 29;BA.debugLine="FontColor = Colors.Black";
listdata._fontcolor = listdata.mostCurrent.__c.getField(false,"Colors").getField(true,"Black");
 //BA.debugLineNum = 30;BA.debugLine="HeaderFontColor = Colors.White";
listdata._headerfontcolor = listdata.mostCurrent.__c.getField(false,"Colors").getField(true,"White");
 //BA.debugLineNum = 31;BA.debugLine="FontSize = 11";
listdata._fontsize = BA.numberCast(float.class, 11);
 //BA.debugLineNum = 32;BA.debugLine="Alignment = Gravity.CENTER 'change to Gravity.LEF";
listdata._alignment = listdata.mostCurrent.__c.getField(false,"Gravity").getField(true,"CENTER");
 //BA.debugLineNum = 33;BA.debugLine="SelectedRowColor = Colors.Blue";
listdata._selectedrowcolor = listdata.mostCurrent.__c.getField(false,"Colors").getField(true,"Blue");
 //BA.debugLineNum = 34;BA.debugLine="Dim list1 As List";
listdata.mostCurrent._list1 = RemoteObject.createNew ("anywheresoftware.b4a.objects.collections.List");
 //BA.debugLineNum = 35;BA.debugLine="End Sub";
return RemoteObject.createImmutable("");
}
public static RemoteObject  _header_click() throws Exception{
try {
		Debug.PushSubsStack("Header_Click (listdata) ","listdata",10,listdata.mostCurrent.activityBA,listdata.mostCurrent,154);
if (RapidSub.canDelegate("header_click")) { return shub.dpm.listdata.remoteMe.runUserSub(false, "listdata","header_click");}
RemoteObject _l = RemoteObject.declareNull("anywheresoftware.b4a.objects.LabelWrapper");
RemoteObject _col = RemoteObject.createImmutable(0);
 BA.debugLineNum = 154;BA.debugLine="Sub Header_Click";
Debug.ShouldStop(33554432);
 BA.debugLineNum = 155;BA.debugLine="Dim l As Label";
Debug.ShouldStop(67108864);
_l = RemoteObject.createNew ("anywheresoftware.b4a.objects.LabelWrapper");Debug.locals.put("l", _l);
 BA.debugLineNum = 156;BA.debugLine="Dim col As Int";
Debug.ShouldStop(134217728);
_col = RemoteObject.createImmutable(0);Debug.locals.put("col", _col);
 BA.debugLineNum = 157;BA.debugLine="l = Sender";
Debug.ShouldStop(268435456);
_l = RemoteObject.declareNull("anywheresoftware.b4a.AbsObjectWrapper").runMethod(false, "ConvertToWrapper", RemoteObject.createNew("anywheresoftware.b4a.objects.LabelWrapper"), listdata.mostCurrent.__c.runMethod(false,"Sender",listdata.mostCurrent.activityBA));
 BA.debugLineNum = 158;BA.debugLine="col = l.Tag";
Debug.ShouldStop(536870912);
_col = BA.numberCast(int.class, _l.runMethod(false,"getTag"));Debug.locals.put("col", _col);
 BA.debugLineNum = 160;BA.debugLine="End Sub";
Debug.ShouldStop(-2147483648);
return RemoteObject.createImmutable("");
}
catch (Exception e) {
			throw Debug.ErrorCaught(e);
		} 
finally {
			Debug.PopSubsStack();
		}}
public static RemoteObject  _init_view() throws Exception{
try {
		Debug.PushSubsStack("init_view (listdata) ","listdata",10,listdata.mostCurrent.activityBA,listdata.mostCurrent,41);
if (RapidSub.canDelegate("init_view")) { return shub.dpm.listdata.remoteMe.runUserSub(false, "listdata","init_view");}
 BA.debugLineNum = 41;BA.debugLine="Sub init_view";
Debug.ShouldStop(256);
 BA.debugLineNum = 43;BA.debugLine="SV.Initialize(0)";
Debug.ShouldStop(1024);
listdata.mostCurrent._sv.runVoidMethod ("Initialize",listdata.mostCurrent.activityBA,(Object)(BA.numberCast(int.class, 0)));
 BA.debugLineNum = 44;BA.debugLine="Activity.LoadLayout(\"LData\")";
Debug.ShouldStop(2048);
listdata.mostCurrent._activity.runMethodAndSync(false,"LoadLayout",(Object)(RemoteObject.createImmutable("LData")),listdata.mostCurrent.activityBA);
 BA.debugLineNum = 46;BA.debugLine="Table = SV.Panel";
Debug.ShouldStop(8192);
listdata.mostCurrent._table = listdata.mostCurrent._sv.runMethod(false,"getPanel");
 BA.debugLineNum = 47;BA.debugLine="Table.Color = TableColor";
Debug.ShouldStop(16384);
listdata.mostCurrent._table.runVoidMethod ("setColor",listdata._tablecolor);
 BA.debugLineNum = 48;BA.debugLine="Activity.AddView(SV, 5%x, 10%y, 90%x, 80%y)";
Debug.ShouldStop(32768);
listdata.mostCurrent._activity.runVoidMethod ("AddView",(Object)((listdata.mostCurrent._sv.getObject())),(Object)(listdata.mostCurrent.__c.runMethod(true,"PerXToCurrent",(Object)(BA.numberCast(float.class, 5)),listdata.mostCurrent.activityBA)),(Object)(listdata.mostCurrent.__c.runMethod(true,"PerYToCurrent",(Object)(BA.numberCast(float.class, 10)),listdata.mostCurrent.activityBA)),(Object)(listdata.mostCurrent.__c.runMethod(true,"PerXToCurrent",(Object)(BA.numberCast(float.class, 90)),listdata.mostCurrent.activityBA)),(Object)(listdata.mostCurrent.__c.runMethod(true,"PerYToCurrent",(Object)(BA.numberCast(float.class, 80)),listdata.mostCurrent.activityBA)));
 BA.debugLineNum = 49;BA.debugLine="Activity.Title=\"Chargen\"";
Debug.ShouldStop(65536);
listdata.mostCurrent._activity.runMethod(false,"setTitle",BA.ObjectToCharSequence("Chargen"));
 BA.debugLineNum = 50;BA.debugLine="ColumnWidth = SV.Width / NumberOfColumns";
Debug.ShouldStop(131072);
listdata._columnwidth = BA.numberCast(int.class, RemoteObject.solve(new RemoteObject[] {listdata.mostCurrent._sv.runMethod(true,"getWidth"),listdata._numberofcolumns}, "/",0, 0));
 BA.debugLineNum = 51;BA.debugLine="SelectedRow = -1";
Debug.ShouldStop(262144);
listdata._selectedrow = BA.numberCast(int.class, -(double) (0 + 1));
 BA.debugLineNum = 53;BA.debugLine="SetHeader(Array As String(\"ID\", \"Charge\", \"Datum\"";
Debug.ShouldStop(1048576);
_setheader(RemoteObject.createNewArray("String",new int[] {3},new Object[] {BA.ObjectToString("ID"),BA.ObjectToString("Charge"),RemoteObject.createImmutable("Datum")}));
 BA.debugLineNum = 55;BA.debugLine="Get_Data";
Debug.ShouldStop(4194304);
_get_data();
 BA.debugLineNum = 56;BA.debugLine="Activity.Title=\"Daten \" & AllgFnkt.PatName";
Debug.ShouldStop(8388608);
listdata.mostCurrent._activity.runMethod(false,"setTitle",BA.ObjectToCharSequence(RemoteObject.concat(RemoteObject.createImmutable("Daten "),listdata.mostCurrent._allgfnkt._patname /*RemoteObject*/ )));
 BA.debugLineNum = 57;BA.debugLine="End Sub";
Debug.ShouldStop(16777216);
return RemoteObject.createImmutable("");
}
catch (Exception e) {
			throw Debug.ErrorCaught(e);
		} 
finally {
			Debug.PopSubsStack();
		}}
public static RemoteObject  _jobdone(RemoteObject _job) throws Exception{
try {
		Debug.PushSubsStack("JobDone (listdata) ","listdata",10,listdata.mostCurrent.activityBA,listdata.mostCurrent,67);
if (RapidSub.canDelegate("jobdone")) { return shub.dpm.listdata.remoteMe.runUserSub(false, "listdata","jobdone", _job);}
RemoteObject _res = RemoteObject.createImmutable("");
RemoteObject _parser = RemoteObject.declareNull("anywheresoftware.b4a.objects.collections.JSONParser");
RemoteObject _i = RemoteObject.createImmutable(0);
RemoteObject _map1 = RemoteObject.declareNull("anywheresoftware.b4a.objects.collections.Map");
RemoteObject _s1 = RemoteObject.createImmutable("");
RemoteObject _s2 = RemoteObject.createImmutable("");
RemoteObject _s3 = RemoteObject.createImmutable("");
Debug.locals.put("Job", _job);
 BA.debugLineNum = 67;BA.debugLine="Sub JobDone(Job As HttpJob)";
Debug.ShouldStop(4);
 BA.debugLineNum = 68;BA.debugLine="ProgressDialogHide";
Debug.ShouldStop(8);
listdata.mostCurrent.__c.runVoidMethod ("ProgressDialogHide");
 BA.debugLineNum = 69;BA.debugLine="If Job.Success Then";
Debug.ShouldStop(16);
if (_job.getField(true,"_success" /*RemoteObject*/ ).<Boolean>get().booleanValue()) { 
 BA.debugLineNum = 70;BA.debugLine="Dim res As String";
Debug.ShouldStop(32);
_res = RemoteObject.createImmutable("");Debug.locals.put("res", _res);
 BA.debugLineNum = 71;BA.debugLine="res = Job.GetString";
Debug.ShouldStop(64);
_res = _job.runClassMethod (shub.dpm.httpjob.class, "_getstring" /*RemoteObject*/ );Debug.locals.put("res", _res);
 BA.debugLineNum = 72;BA.debugLine="Dim parser As JSONParser";
Debug.ShouldStop(128);
_parser = RemoteObject.createNew ("anywheresoftware.b4a.objects.collections.JSONParser");Debug.locals.put("parser", _parser);
 BA.debugLineNum = 73;BA.debugLine="parser.Initialize(res)";
Debug.ShouldStop(256);
_parser.runVoidMethod ("Initialize",(Object)(_res));
 BA.debugLineNum = 75;BA.debugLine="Log(\"Response from server: \" & res)";
Debug.ShouldStop(1024);
listdata.mostCurrent.__c.runVoidMethod ("LogImpl","15963784",RemoteObject.concat(RemoteObject.createImmutable("Response from server: "),_res),0);
 BA.debugLineNum = 77;BA.debugLine="Select Job.JobName";
Debug.ShouldStop(4096);
switch (BA.switchObjectToInt(_job.getField(true,"_jobname" /*RemoteObject*/ ),BA.ObjectToString("DelData"),BA.ObjectToString("GetData"))) {
case 0: {
 BA.debugLineNum = 79;BA.debugLine="list1.Clear";
Debug.ShouldStop(16384);
listdata.mostCurrent._list1.runVoidMethod ("Clear");
 BA.debugLineNum = 80;BA.debugLine="Table.RemoveAllViews";
Debug.ShouldStop(32768);
listdata.mostCurrent._table.runVoidMethod ("RemoveAllViews");
 BA.debugLineNum = 81;BA.debugLine="init_view";
Debug.ShouldStop(65536);
_init_view();
 break; }
case 1: {
 BA.debugLineNum = 86;BA.debugLine="list1 = parser.NextArray";
Debug.ShouldStop(2097152);
listdata.mostCurrent._list1 = _parser.runMethod(false,"NextArray");
 BA.debugLineNum = 87;BA.debugLine="Dim i As Int";
Debug.ShouldStop(4194304);
_i = RemoteObject.createImmutable(0);Debug.locals.put("i", _i);
 BA.debugLineNum = 88;BA.debugLine="For i=0 To list1.Size-1";
Debug.ShouldStop(8388608);
{
final int step16 = 1;
final int limit16 = RemoteObject.solve(new RemoteObject[] {listdata.mostCurrent._list1.runMethod(true,"getSize"),RemoteObject.createImmutable(1)}, "-",1, 1).<Integer>get().intValue();
_i = BA.numberCast(int.class, 0) ;
for (;(step16 > 0 && _i.<Integer>get().intValue() <= limit16) || (step16 < 0 && _i.<Integer>get().intValue() >= limit16) ;_i = RemoteObject.createImmutable((int)(0 + _i.<Integer>get().intValue() + step16))  ) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 89;BA.debugLine="Dim map1 As Map";
Debug.ShouldStop(16777216);
_map1 = RemoteObject.createNew ("anywheresoftware.b4a.objects.collections.Map");Debug.locals.put("map1", _map1);
 BA.debugLineNum = 90;BA.debugLine="map1=list1.Get(i)";
Debug.ShouldStop(33554432);
_map1 = RemoteObject.declareNull("anywheresoftware.b4a.AbsObjectWrapper").runMethod(false, "ConvertToWrapper", RemoteObject.createNew("anywheresoftware.b4a.objects.collections.Map"), listdata.mostCurrent._list1.runMethod(false,"Get",(Object)(_i)));
 BA.debugLineNum = 91;BA.debugLine="Dim s1 As String";
Debug.ShouldStop(67108864);
_s1 = RemoteObject.createImmutable("");Debug.locals.put("s1", _s1);
 BA.debugLineNum = 92;BA.debugLine="Dim s2 As String";
Debug.ShouldStop(134217728);
_s2 = RemoteObject.createImmutable("");Debug.locals.put("s2", _s2);
 BA.debugLineNum = 93;BA.debugLine="Dim s3 As String";
Debug.ShouldStop(268435456);
_s3 = RemoteObject.createImmutable("");Debug.locals.put("s3", _s3);
 BA.debugLineNum = 94;BA.debugLine="s1=map1.Get(\"id\")";
Debug.ShouldStop(536870912);
_s1 = BA.ObjectToString(_map1.runMethod(false,"Get",(Object)((RemoteObject.createImmutable("id")))));Debug.locals.put("s1", _s1);
 BA.debugLineNum = 95;BA.debugLine="s2=map1.Get(\"charge\")";
Debug.ShouldStop(1073741824);
_s2 = BA.ObjectToString(_map1.runMethod(false,"Get",(Object)((RemoteObject.createImmutable("charge")))));Debug.locals.put("s2", _s2);
 BA.debugLineNum = 96;BA.debugLine="s3=map1.Get(\"datum\")";
Debug.ShouldStop(-2147483648);
_s3 = BA.ObjectToString(_map1.runMethod(false,"Get",(Object)((RemoteObject.createImmutable("datum")))));Debug.locals.put("s3", _s3);
 BA.debugLineNum = 97;BA.debugLine="AddRow(Array As String(s1,s2,s3))";
Debug.ShouldStop(1);
_addrow(RemoteObject.createNewArray("String",new int[] {3},new Object[] {_s1,_s2,_s3}));
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 99;BA.debugLine="If list1.Size<1 Then";
Debug.ShouldStop(4);
if (RemoteObject.solveBoolean("<",listdata.mostCurrent._list1.runMethod(true,"getSize"),BA.numberCast(double.class, 1))) { 
 BA.debugLineNum = 100;BA.debugLine="ToastMessageShow(\"Keine Daten vorhanden.\",Tru";
Debug.ShouldStop(8);
listdata.mostCurrent.__c.runVoidMethod ("ToastMessageShow",(Object)(BA.ObjectToCharSequence("Keine Daten vorhanden.")),(Object)(listdata.mostCurrent.__c.getField(true,"True")));
 BA.debugLineNum = 101;BA.debugLine="Return";
Debug.ShouldStop(16);
if (true) return RemoteObject.createImmutable("");
 };
 break; }
}
;
 };
 BA.debugLineNum = 105;BA.debugLine="End Sub";
Debug.ShouldStop(256);
return RemoteObject.createImmutable("");
}
catch (Exception e) {
			throw Debug.ErrorCaught(e);
		} 
finally {
			Debug.PopSubsStack();
		}}
public static RemoteObject  _numberofrows() throws Exception{
try {
		Debug.PushSubsStack("NumberOfRows (listdata) ","listdata",10,listdata.mostCurrent.activityBA,listdata.mostCurrent,219);
if (RapidSub.canDelegate("numberofrows")) { return shub.dpm.listdata.remoteMe.runUserSub(false, "listdata","numberofrows");}
 BA.debugLineNum = 219;BA.debugLine="Sub NumberOfRows As Int";
Debug.ShouldStop(67108864);
 BA.debugLineNum = 220;BA.debugLine="Return Table.NumberOfViews / NumberOfColumns";
Debug.ShouldStop(134217728);
if (true) return BA.numberCast(int.class, RemoteObject.solve(new RemoteObject[] {listdata.mostCurrent._table.runMethod(true,"getNumberOfViews"),listdata._numberofcolumns}, "/",0, 0));
 BA.debugLineNum = 221;BA.debugLine="End Sub";
Debug.ShouldStop(268435456);
return RemoteObject.createImmutable(0);
}
catch (Exception e) {
			throw Debug.ErrorCaught(e);
		} 
finally {
			Debug.PopSubsStack();
		}}
public static RemoteObject  _process_globals() throws Exception{
 //BA.debugLineNum = 6;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 8;BA.debugLine="End Sub";
return RemoteObject.createImmutable("");
}
public static RemoteObject  _selectrow(RemoteObject _row) throws Exception{
try {
		Debug.PushSubsStack("SelectRow (listdata) ","listdata",10,listdata.mostCurrent.activityBA,listdata.mostCurrent,161);
if (RapidSub.canDelegate("selectrow")) { return shub.dpm.listdata.remoteMe.runUserSub(false, "listdata","selectrow", _row);}
int _col = 0;
Debug.locals.put("Row", _row);
 BA.debugLineNum = 161;BA.debugLine="Sub SelectRow(Row As Int)";
Debug.ShouldStop(1);
 BA.debugLineNum = 163;BA.debugLine="If SelectedRow > -1 Then";
Debug.ShouldStop(4);
if (RemoteObject.solveBoolean(">",listdata._selectedrow,BA.numberCast(double.class, -(double) (0 + 1)))) { 
 BA.debugLineNum = 164;BA.debugLine="For col = 0 To NumberOfColumns - 1";
Debug.ShouldStop(8);
{
final int step2 = 1;
final int limit2 = RemoteObject.solve(new RemoteObject[] {listdata._numberofcolumns,RemoteObject.createImmutable(1)}, "-",1, 1).<Integer>get().intValue();
_col = 0 ;
for (;(step2 > 0 && _col <= limit2) || (step2 < 0 && _col >= limit2) ;_col = ((int)(0 + _col + step2))  ) {
Debug.locals.put("col", _col);
 BA.debugLineNum = 165;BA.debugLine="GetView(SelectedRow, col).Color = Colors.Transp";
Debug.ShouldStop(16);
_getview(listdata._selectedrow,BA.numberCast(int.class, _col)).runVoidMethod ("setColor",listdata.mostCurrent.__c.getField(false,"Colors").getField(true,"Transparent"));
 }
}Debug.locals.put("col", _col);
;
 };
 BA.debugLineNum = 168;BA.debugLine="SelectedRow = Row";
Debug.ShouldStop(128);
listdata._selectedrow = _row;
 BA.debugLineNum = 169;BA.debugLine="For col = 0 To NumberOfColumns - 1";
Debug.ShouldStop(256);
{
final int step7 = 1;
final int limit7 = RemoteObject.solve(new RemoteObject[] {listdata._numberofcolumns,RemoteObject.createImmutable(1)}, "-",1, 1).<Integer>get().intValue();
_col = 0 ;
for (;(step7 > 0 && _col <= limit7) || (step7 < 0 && _col >= limit7) ;_col = ((int)(0 + _col + step7))  ) {
Debug.locals.put("col", _col);
 BA.debugLineNum = 170;BA.debugLine="GetView(Row, col).Color = SelectedRowColor";
Debug.ShouldStop(512);
_getview(_row,BA.numberCast(int.class, _col)).runVoidMethod ("setColor",listdata._selectedrowcolor);
 }
}Debug.locals.put("col", _col);
;
 BA.debugLineNum = 172;BA.debugLine="End Sub";
Debug.ShouldStop(2048);
return RemoteObject.createImmutable("");
}
catch (Exception e) {
			throw Debug.ErrorCaught(e);
		} 
finally {
			Debug.PopSubsStack();
		}}
public static RemoteObject  _setcell(RemoteObject _row,RemoteObject _col,RemoteObject _value) throws Exception{
try {
		Debug.PushSubsStack("SetCell (listdata) ","listdata",10,listdata.mostCurrent.activityBA,listdata.mostCurrent,223);
if (RapidSub.canDelegate("setcell")) { return shub.dpm.listdata.remoteMe.runUserSub(false, "listdata","setcell", _row, _col, _value);}
Debug.locals.put("Row", _row);
Debug.locals.put("Col", _col);
Debug.locals.put("Value", _value);
 BA.debugLineNum = 223;BA.debugLine="Sub SetCell(Row As Int, Col As Int, Value As Strin";
Debug.ShouldStop(1073741824);
 BA.debugLineNum = 224;BA.debugLine="GetView(Row, Col).Text = Value";
Debug.ShouldStop(-2147483648);
_getview(_row,_col).runMethod(true,"setText",BA.ObjectToCharSequence(_value));
 BA.debugLineNum = 225;BA.debugLine="End Sub";
Debug.ShouldStop(1);
return RemoteObject.createImmutable("");
}
catch (Exception e) {
			throw Debug.ErrorCaught(e);
		} 
finally {
			Debug.PopSubsStack();
		}}
public static RemoteObject  _setheader(RemoteObject _values) throws Exception{
try {
		Debug.PushSubsStack("SetHeader (listdata) ","listdata",10,listdata.mostCurrent.activityBA,listdata.mostCurrent,201);
if (RapidSub.canDelegate("setheader")) { return shub.dpm.listdata.remoteMe.runUserSub(false, "listdata","setheader", _values);}
int _i = 0;
RemoteObject _l = RemoteObject.declareNull("anywheresoftware.b4a.objects.LabelWrapper");
Debug.locals.put("Values", _values);
 BA.debugLineNum = 201;BA.debugLine="Sub SetHeader(Values() As String)";
Debug.ShouldStop(256);
 BA.debugLineNum = 202;BA.debugLine="If Header.IsInitialized Then Return 'should only";
Debug.ShouldStop(512);
if (listdata.mostCurrent._header.runMethod(true,"IsInitialized").<Boolean>get().booleanValue()) { 
if (true) return RemoteObject.createImmutable("");};
 BA.debugLineNum = 203;BA.debugLine="Header.Initialize(\"\")";
Debug.ShouldStop(1024);
listdata.mostCurrent._header.runVoidMethod ("Initialize",listdata.mostCurrent.activityBA,(Object)(RemoteObject.createImmutable("")));
 BA.debugLineNum = 204;BA.debugLine="For i = 0 To NumberOfColumns - 1";
Debug.ShouldStop(2048);
{
final int step3 = 1;
final int limit3 = RemoteObject.solve(new RemoteObject[] {listdata._numberofcolumns,RemoteObject.createImmutable(1)}, "-",1, 1).<Integer>get().intValue();
_i = 0 ;
for (;(step3 > 0 && _i <= limit3) || (step3 < 0 && _i >= limit3) ;_i = ((int)(0 + _i + step3))  ) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 205;BA.debugLine="Dim l As Label";
Debug.ShouldStop(4096);
_l = RemoteObject.createNew ("anywheresoftware.b4a.objects.LabelWrapper");Debug.locals.put("l", _l);
 BA.debugLineNum = 206;BA.debugLine="l.Initialize(\"header\")";
Debug.ShouldStop(8192);
_l.runVoidMethod ("Initialize",listdata.mostCurrent.activityBA,(Object)(RemoteObject.createImmutable("header")));
 BA.debugLineNum = 207;BA.debugLine="l.Text = Values(i)";
Debug.ShouldStop(16384);
_l.runMethod(true,"setText",BA.ObjectToCharSequence(_values.getArrayElement(true,BA.numberCast(int.class, _i))));
 BA.debugLineNum = 208;BA.debugLine="l.Gravity = Gravity.CENTER";
Debug.ShouldStop(32768);
_l.runMethod(true,"setGravity",listdata.mostCurrent.__c.getField(false,"Gravity").getField(true,"CENTER"));
 BA.debugLineNum = 209;BA.debugLine="l.TextSize = FontSize";
Debug.ShouldStop(65536);
_l.runMethod(true,"setTextSize",listdata._fontsize);
 BA.debugLineNum = 210;BA.debugLine="l.Color = HeaderColor";
Debug.ShouldStop(131072);
_l.runVoidMethod ("setColor",listdata._headercolor);
 BA.debugLineNum = 211;BA.debugLine="l.TextColor = HeaderFontColor";
Debug.ShouldStop(262144);
_l.runMethod(true,"setTextColor",listdata._headerfontcolor);
 BA.debugLineNum = 214;BA.debugLine="l.Tag = i";
Debug.ShouldStop(2097152);
_l.runMethod(false,"setTag",RemoteObject.createImmutable((_i)));
 BA.debugLineNum = 215;BA.debugLine="Header.AddView(l, ColumnWidth * i, 0, ColumnWidt";
Debug.ShouldStop(4194304);
listdata.mostCurrent._header.runVoidMethod ("AddView",(Object)((_l.getObject())),(Object)(RemoteObject.solve(new RemoteObject[] {listdata._columnwidth,RemoteObject.createImmutable(_i)}, "*",0, 1)),(Object)(BA.numberCast(int.class, 0)),(Object)(listdata._columnwidth),(Object)(listdata._rowheight));
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 217;BA.debugLine="Activity.AddView(Header, SV.Left, SV.Top - RowHei";
Debug.ShouldStop(16777216);
listdata.mostCurrent._activity.runVoidMethod ("AddView",(Object)((listdata.mostCurrent._header.getObject())),(Object)(listdata.mostCurrent._sv.runMethod(true,"getLeft")),(Object)(RemoteObject.solve(new RemoteObject[] {listdata.mostCurrent._sv.runMethod(true,"getTop"),listdata._rowheight}, "-",1, 1)),(Object)(listdata.mostCurrent._sv.runMethod(true,"getWidth")),(Object)(listdata._rowheight));
 BA.debugLineNum = 218;BA.debugLine="End Sub";
Debug.ShouldStop(33554432);
return RemoteObject.createImmutable("");
}
catch (Exception e) {
			throw Debug.ErrorCaught(e);
		} 
finally {
			Debug.PopSubsStack();
		}}
}